unit U_spiel;

interface

uses ExtCtrls, SysUtils, Dialogs;

type
     TZug = 0..6;
     TSpieler = (Computer, Mensch);
     TPosition = record
       Summe: integer;
       Augen: TZug;
       amZug: TSpieler;
     end;

     TSpiel = class
     private
       PB: TPaintbox;
       Zielzahl: integer;
       Position: TPosition;
       function zulaessig(Position: TPosition; Zug: TZug): boolean;
       procedure ausfuehren(Position: TPosition; Zug: TZug; var neuPosition: TPosition);
       function amEnde(Position: TPosition): boolean;
       function Spielerzug: TZug;
       function Computerzug: TZug;
     public
       constructor create(Startzahl: TZug; Zielzahl: integer; amZug: TSpieler; Ausgabe: TPaintbox);
       procedure Ausgabe;
       procedure Starten;
     end;

implementation


{ Methode der Klasse TSpiel }

constructor TSpiel.create(Startzahl: TZug; Zielzahl: integer; amZug: TSpieler; Ausgabe: TPaintbox);
begin
  PB:= Ausgabe;
  Position.Summe:= 0;
  Position.Augen:= Startzahl;
  Position.amZug:= amZug;
  Self.Zielzahl:= Zielzahl;
end;

function TSpiel.zulaessig(Position: TPosition; Zug: TZug): boolean;
begin
  zulaessig:= (Position.Summe+Zug <= Zielzahl) and
              (Position.Augen <> Zug) and (Position.Augen + Zug <>7);
end;

procedure TSpiel.ausfuehren(Position: TPosition; Zug: TZug; var neuPosition: TPosition);
begin
  neuPosition.Summe:= Position.Summe+Zug;
  neuPosition.Augen:= Zug;
  if Position.amZug = Computer
    then neuPosition.amZug:= Mensch
    else neuPosition.amZug:= Computer;
end;

function TSpiel.amEnde(Position: TPosition): boolean;
begin
  amEnde:= (Position.Summe=Zielzahl) or
           (Position.Summe = Zielzahl - 1) and ((Position.Augen = 1) or (Position.Augen = 6));
end;

procedure TSpiel.Ausgabe;
begin
  PB.Refresh;
  if Position.amZug = Mensch
    then PB.Canvas.Textout(10,10,'am Zug: Spieler')
    else PB.Canvas.Textout(10,10,'am Zug: Computer');
  PB.Canvas.Textout(10,30,'es liegt die Zahl '+IntToStr(Position.Augen)+' oben.');
  PB.Canvas.Textout(10,50,'Die Augensumme betrgt: '+IntToStr(Position.Summe));

end;

function TSpiel.Spielerzug: TZug;
var zug: TZug;
begin
  repeat
    zug:= StrToInt(inputbox('Zahl','Zahl eingeben',''));
  until zulaessig(Position,zug);
  Spielerzug:= Zug;
end;

function TSpiel.Computerzug: TZug;
var besterZug, Verlegenheitszug: TZug;
    besterWert: integer;
    Zug: TZug;

  function Endwert(Position: TPosition): integer;
  begin
    if (Position.Summe<Zielzahl)
    then Endwert:= 0
    else Endwert:= +1;
  end;

  function negmax(Position: TPosition; var besterZug: TZug): integer;
  var Wert, NachfolgerWert: integer;
      Probezug, DummyZug: TZug;
      NachfolgePosition: TPosition;
  begin
    if amEnde(Position)
    then negmax:= -Endwert(Position)
    else begin
           Wert:= -2;
           for Probezug:= 1 to 6
           do begin
                if zulaessig(Position,Probezug)
                then begin
                       ausfuehren(Position,Probezug,NachfolgePosition);
                       Nachfolgerwert:= -negmax(NachfolgePosition,DummyZug);
                       if NachfolgerWert > Wert
                       then begin
                              Wert:= NachfolgerWert;
                              besterZug:= Probezug;
                            end;
                     end;
              end;
           negmax:= Wert;
         end;
  end;

begin
  besterWert:= negmax(Position,besterZug);
  if besterWert >= 0
  then Zug:= besterZug
  else begin
         Repeat
           Verlegenheitszug:= random(6)+1;
         Until zulaessig(Position,Verlegenheitszug);
         Zug:= Verlegenheitszug;
       end;
   ShowMessage('Der Computer zieht: '+IntToStr(Zug));
   ComputerZug:= Zug;
end;

procedure TSpiel.Starten;
var Zug: TZug;
begin
  while not amEnde(Position)
  do begin
       if Position.amZug = Mensch
         then Zug:= Spielerzug
         else Zug:= Computerzug;
       ausfuehren(Position,Zug,Position);
       Ausgabe;
     end;
  if Position.Summe<Zielzahl
  then ShowMessage('Unentschieden!')
  else if Position.amZug=Mensch
       then ShowMessage('Der Computer hat gewonnen!')
       else ShowMessage('Der Spieler hat gewonnen!');
end;

end.
